/**
 * abgespecktes frontend for testing purpose.
 * C source.
 *
 **/
 
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include "backend.h"

void puncher_frontend_visualize_byte(unsigned char buf) {
	/* Draw a papertape byte (like the perl program) */
	unsigned char against = 0x01;
	unsigned char check;
	int pos;
	
	printf("|");
	for(pos=0; pos < 8; pos++) {
		if(pos == 3) /* Streifenfuehrung */
			printf(".");
		check = buf;
		check >>= pos;
		
		if((check & against) == 0)
			printf(" "); /* bit nicht gesetzt */
		else
			printf("*"); /* bit gesetzt */
	} /*for */
	printf("|");
}

 
int main(int argc, char **argv) {
	PuncherBackend *puncher;
	int ret;

	printf("Paper Tape Project -- Windows user mode puncher\n");
	
	puncher = puncher_backend_new(1);

	for(int xy=0;xy<10;xy++) {
		unsigned char buf; /* stdin 1 byte buffer */

		ret = read(0, &buf, 1); /* 1 byte from stdin */
		if(ret < 0) {
			printf("HARD READ IN EROR\n");
			puncher_backend_destroy(puncher);
			return 1;
		}

		if(ret == 0) {/* EOF, end of input, etc. */
			printf("EOF STDIN.\n");
			break;
		}

		/* Visualisation of the byte in a stdout line */
		puncher_frontend_visualize_byte(buf);
		printf(" 0x%02x=%03i ", buf, buf);

        /* call the backend */
        ret = puncher_backend_write_byte(puncher, buf);

		if(ret < 0) {
			printf("BACKEND HARD ERROR: calling write backend\n");
			puncher_backend_destroy(puncher);
			return 1;
		} else if(ret == 0) {
		        printf("=)\n"); // everything okay
		} else if(ret == 1) {
		        printf(":-(\n"); // punch not okay, but go on.
		}
	} /* for stdin */

	if(puncher_backend_destroy(puncher)) {
		perror("finishing backend");
		return 1;
	} else
		return 0;
}
